// hrtf-controler.cc -- spatial audio controler for the SGI
//
// Programmer:    Craig Stuart Sapp <craig@ccrma.stanford.edu>
// Creation Date: Tue Jul  2 17:02:29 GMT-0700 1996
// Last Modified: Tue Jul  2 17:02:34 GMT-0700 1996
// Filename:      /user/c/craig/lang/c/drum/examples/hrtf-controler.cc
// Syntax:        C++ (Gnu C++ compiler: /Local/Unix/bin/g++)
// $Smake:        g++ -O -o %b %f -I../include -L../lib %
//                -ldrum -lmidi -loptions && strip %b
//                Type "../bin/smake FILENAME" to compile this file.
//

#include <math.h>
#include "main.cc"


/***************** Beginning of user function *****************************/


/*---------------- Documentation functions -------------------------------*/

void description(void) {
   cout
   << "______________________________________________________________ \n"
   << "| Description:                                                |\n"
   << "|   Controls the 3Daudio program from MIT Media labs on SGI.  |\n"
   << "|                          -- Craig Stuart Sapp,  2 Jul 1996  |\n"
   << "---------------------------------------------------------------\n"
   ;
}


void programhelp(void) {
   cout
   << ">                                                              \n"
   << "> Baton 1:                                                     \n"
   << ">    x1p: one degree of freedom in location                    \n"
   << ">    y1p: one degree of freedom in location                    \n"
   << ">    z1p: one degree of freedom in location                    \n"
   << "> Baton 2: Nothing                                             \n"
   << ">                                                              \n"
   << ">   +b14: Command mode                                         \n"
   << ">   +b15: This help screen                                     \n"
   << ">                                                              \n"
   ;
}


/*---------------- Initialization algorithms -----------------------------*/

void initialization(void) { 
   drum.setPollRate(200);       // poll rate of baton set to 200 milliseconds
   description();
}


/*---------------- Main loop algorithms ----------------------------------*/

void mainloopalgorithms(void) { 
   if (drum.checkPollTime()) {
      drum.pollBaton1();

      if (drum.x1p != drum.x1po)
         midi.cont(CH_1, 1, drum.x1p);
      if (drum.y1p != drum.y1po)
         midi.cont(CH_1, 2, drum.y1p);
      if (drum.z1p != drum.z1po)
         midi.cont(CH_1, 3, drum.z1p);

   }
}


/*---------------- Trigger response functions ----------------------------*/

void stick1trig(void) { 
}

void stick2trig(void) { 
}

void b14plustrig(void) { commandmode(); }

void b15plustrig(void) { programhelp(); }

/*---------------- Poll response algorithms ------------------------------*/

void stick1pollresponse(void) { }
void stick2pollresponse(void) { }
void potspollresponse(void) { }

/*---------------- Actions to take just before leaving program -----------*/

void cleanup(void) { }

/***************** End of user functions **********************************/

